#ifndef API_H
#define API_H


#define CRYPTO_BYTES 32
//#define CRYPTO_BYTES 48
//#define CRYPTO_BYTES 64

#define SECRET_INTERNAL  CRYPTO_BYTES *5/4
#define CRYPTO_SECRETKEYBYTES  SECRET_INTERNAL * 83 /33
#define CRYPTO_PUBLICKEYBYTES  CRYPTO_SECRETKEYBYTES * 3
#define CRYPTO_CIPHERTEXTBYTES CRYPTO_PUBLICKEYBYTES + CRYPTO_BYTES

#define CRYPTO_ALGNAME "RVB"

#define RVB_INVALID_PUBLIC -5


int crypto_kem_keypair(unsigned char *pk, unsigned char *sk);
int crypto_kem_enc(unsigned char *ct, unsigned char *ss, const unsigned char *pk);
int crypto_kem_dec(unsigned char *ss, const unsigned char *ct, const unsigned char *sk);


//! pre fixed common value, size of buffer has to be CRYPTO_PUBLIC_KEYBYTES
int common_value(unsigned char* x);
//! for DEBUG
int shared_secret(unsigned char *out, const char* public_val, const char *secret_key);
void make_new_common();

#endif // API_H
